【POJ 3658】Artificial Lake

Artificial Lake

Time Limit: 3000MS   Memory Limit: 65536K
Total Submissions: 1862   Accepted: 625

Description

The oppressively hot summer days have raised the cows‘ clamoring to its highest level. Farmer John has finally decided to build an artificial lake. For his engineering studies, he is modeling the lake as a two-dimensional landscape consisting of a contiguous sequence of N soon-to-be-submerged levels (1 ≤ N ≤ 100,000) conveniently numbered 1..N from left to right.

Each level i is described by two integers, its width Wi (1 ≤ Wi ≤ 1,000) and height (like a relative elevation) Hi (1 ≤ Hi ≤ 1,000,000). The heights of FJ‘s levels are unique. An infinitely tall barrier encloses the lake‘s model on the left and right. One example lake profile is shown below.

         *             *  :
         *             *  :
         *             *  8
         *    ***      *  7
         *    ***      *  6
         *    ***      *  5
         *    **********  4 <- height
         *    **********  3
         ***************  2
         ***************  1
Level    |  1 |2|  3   |

In FJ‘s model, he starts filling his lake at sunrise by flowing water into the bottom of the lowest elevation at a rate of 1 square unit of water per minute. The water falls directly downward until it hits something, and then it flows and spreads as room-temperature water always does. As in all good models, assume that falling and flowing happen instantly. Determine the time at which each elevation‘s becomes submerged by a single unit of water.

WATER              WATER OVERFLOWS
       |                       |
     * |          *      *     |      *      *            *
     * V          *      *     V      *      *            *
     *            *      *    ....    *      *~~~~~~~~~~~~*
     *    **      *      *~~~~** :    *      *~~~~**~~~~~~*
     *    **      *      *~~~~** :    *      *~~~~**~~~~~~*
     *    **      *      *~~~~**~~~~~~*      *~~~~**~~~~~~*
     *    *********      *~~~~*********      *~~~~*********
     *~~~~*********      *~~~~*********      *~~~~*********
     **************      **************      **************
     **************      **************      **************

     After 4 mins        After 26 mins       After 50 mins
     Lvl 1 submerged     Lvl 3 submerged     Lvl 2 submerged

Warning: The answer will not always fit in 32 bits.

Input

* Line 1: A single integer: N
* Lines 2..N+1: Line i+1 describes level i with two space-separated integers: Wi and Hi

Output

* Lines 1..N: Line i contains a single integer that is the number of minutes that since sunrise when level #i is covered by water of height 1.

Sample Input

3
4 2
2 7
6 4

Sample Output

4
50
26

Source

USACO 2008 January Gold

这道题其实是一道不是纯属意义的模拟。

从最低的平台开始注水,然后向上一直灌,有太多情况了,我们甚至无法判断。

我们可以倒过来想,我们是可以知道水位灌满达到最高的平台的高度+1的时候的体积(即时间)。

然后我们记录这个答案,把这个大区间从此处断开分成两个小区间,然后先处理远离最低平台(即注水处)的那个区间,反复进行此过程即可。

找最高的平台我们可以用RMQ预处理。

时间复杂度O(Nlog2N)。

#include<cstdio>
#include<cstring>

using namespace std;

const int MAXN = 100005;

int n;
int d[MAXN][17], num[MAXN][17], w[MAXN], h[MAXN];
int _high, _num, mint, minn;
long long sum[MAXN];
long long ans[MAXN];
long long t;

void init()
{
    sum[0] = w[0] = 0;
    mint = 0x7fffffff;
    for (int i = 1; i <= n; ++i) sum[i] += sum[i - 1];
    for (int i = 1; i <= n; ++i) w[i] += w[i - 1];
    for (int i = 1; i <= n; ++i)
        if (mint > h[i])
        {
            mint = h[i];
            minn = i;
        }
    for (int j = 1; (1 << j) <= n; ++j)
        for (int i = 1; i + (1 << (j - 1)) <= n; ++i)
        {
            int other = d[i + (1 << (j - 1))][j - 1];
            if (d[i][j - 1] < other)
            {
                d[i][j] = other;
                num[i][j] = num[i + (1 << (j - 1))][j - 1];
            }
            else
            {
                d[i][j] = d[i][j - 1];
                num[i][j] = num[i][j - 1];
            }
        }
}

void findout(int L, int R)
{
    if (L == R)
    {
        _high = h[L];
        _num = L;
        return;
    }
    int k = 0;
    while ((1 << (k + 1)) <= (R - L + 1)) k++;
    if (d[L][k] > d[R - (1 << k) + 1][k])
    {
        _high = d[L][k];
        _num = num[L][k];
    }
    else
    {
        _high = d[R - (1 << k) + 1][k];
        _num = num[R - (1 << k) + 1][k];
    }
}

int abs(int x)
{
    return x < 0 ? -x : x;
}

void solve(int l, int r, int lasth)
{
    if (l > r) return;
    findout(l, r);
    t -= (long long)(w[r] - w[l - 1]) * (long long)(lasth - h[_num] - 1);
    ans[_num] = t;
    t -= w[r] - w[l - 1];
    int tnum = _num, thigh = _high;
    if (l <= minn && minn <= tnum - 1)
    {
        solve(tnum + 1, r, thigh);
        solve(l, tnum - 1, thigh);
    }
    else if (tnum + 1 <= minn && minn <= r)
        {
            solve(l, tnum - 1, thigh);
            solve(tnum + 1, r, thigh);
        }
        else
        if (abs(l - minn) > abs(r - minn))
        {
            solve(l, tnum - 1, thigh);
            solve(tnum + 1, r, thigh);
        }
        else
        {
            solve(tnum + 1, r, thigh);
            solve(l, tnum - 1, thigh);
        }
}

int main()
{
    scanf("%d", &n);
    memset(d, 0, sizeof(d));
    for (int i = 1; i <= n; ++i)
    {
        scanf("%d%d", &w[i], &h[i]);
        d[i][0] = h[i];
        num[i][0] = i;
        sum[i] = (long long)w[i] * h[i];
    }
    init();
    findout(1, n);
    t = (long long)w[n] * (long long)(_high + 1) - sum[n];
    solve(1, n, _high + 1);
    for (int i = 1; i <= n; ++i) printf("%I64d\n", ans[i]);
    return 0;
}
时间: 2025-01-08 01:39:14

【POJ 3658】Artificial Lake的相关文章

【POJ 1408】 Fishnet (叉积求面积)

[POJ 1408] Fishnet (叉积求面积) 一个1*1㎡的池塘 有2*n条线代表渔网 问这些网中围出来的最大面积 一个有效面积是相邻两行和相邻两列中间夹的四边形 Input为n 后面跟着四行 每行n个浮点数 每一行分别代表a,b,c,d 如图 并且保证a(i) > a(i-1) b(i) > b(i-1) c(i) > c(i-1) d(i) > d(i-1) n(n <= 30)*2+4(四个岸)条边 枚举点数就行 相邻的四个四个点枚举 找出围出的最大面积 找点用

【POJ 2513】Colored Sticks

[POJ 2513]Colored Sticks 并查集+字典树+欧拉通路 第一次做这么混的题..太混了-- 不过题不算难 字典树用来查字符串对应图中的点 每个单词做一个点(包括重复单词 题意就是每个边走且直走一次(欧拉通路 欧拉图的判定: 没有或者只有两个奇数度的点的图叫做欧拉图 有这些就可以解答此题了 另外需要注意题目范围是25W个木棍 所以最多可能有50W个点 卡了好多个RE 代码如下: #include <iostream> #include <cstdlib> #incl

2292: 【POJ Challenge 】永远挑战

2292: [POJ Challenge ]永远挑战 Time Limit: 10 Sec  Memory Limit: 128 MBSubmit: 553  Solved: 230[Submit][Status][Discuss] Description lqp18_31和1tthinking经常出题来虐ftiasch.有一天, lqp18_31搞了一个有向图,每条边的长度都是1. 他想让ftiasch求出点1到点 N 的最短路."水题啊.", ftiasch这么说道. 所以1tth

【POJ 1201】 Intervals(差分约束系统)

[POJ 1201] Intervals(差分约束系统) 11 1716的升级版 把原本固定的边权改为不固定. Intervals Time Limit: 2000MS   Memory Limit: 65536K Total Submissions: 23817   Accepted: 9023 Description You are given n closed, integer intervals [ai, bi] and n integers c1, ..., cn. Write a p

【POJ 1228】Grandpa&#39;s Estate 凸包

找到凸包后暴力枚举边进行$check$,注意凸包是一条线(或者说两条线)的情况要输出$NO$ #include<cmath> #include<cstdio> #include<cstring> #include<algorithm> #define N 1003 #define read(x) x = getint() using namespace std; inline int getint() { int k = 0, fh = 1; char c

【POJ 2750】 Potted Flower(线段树套dp)

[POJ 2750] Potted Flower(线段树套dp) Time Limit: 2000MS   Memory Limit: 65536K Total Submissions: 4566   Accepted: 1739 Description The little cat takes over the management of a new park. There is a large circular statue in the center of the park, surrou

【POJ 2480】Longge&#39;s problem(欧拉函数)

题意 求$ \sum_{i=1}^n gcd(i,n) $ 给定 $n(1\le n\le 2^{32}) $. 链接 分析 用欧拉函数$φ(x)$求1到x-1有几个和x互质的数. gcd(i,n)必定是n的一个约数.若p是n的约数,那么gcd(i,n)==p的有$φ(n/p)$个数,因为要使gcd(i,n)==p,i/p和n/p必须是互质的.那么就是求i/p和n/p互质的i在[1,n]里有几个,就等价于,1/p,2/p,...,n/p里面有几个和n/p互质,即φ(n/p). 求和的话,约数为p

【POJ 3321】 Apple Tree (dfs重标号设区间+树状数组求和)

[POJ 3321] Apple Tree (dfs重标号设区间+树状数组求和) Apple Tree Time Limit: 2000MS   Memory Limit: 65536K Total Submissions: 21966   Accepted: 6654 Description There is an apple tree outside of kaka's house. Every autumn, a lot of apples will grow in the tree. K

【POJ 1260】Pearls

[POJ 1260]Pearls dp问题 最近做背包做多了 一做动规就往背包想-- 这题其实也有点背包的意思(然而只是做背包做的看啥都像背包-- c件物品 有各自的数量a 和价值p 每进行一次交易的花费cost = (物品数+10)*价格 低价物品可以用高价一起购买 一次交易只能按照一种价值购买 初始dp[0] = 0 dp数组下标为物品件数 枚举物品种类 没枚举一种物品 遍历该物品之前物品量 假设之前有num件物品 当前枚举到的物品价值p 那么就要找到min(dp[k(0~num)] + (